FreeBSD Administration - Support #679

Install GitLab 8 From Source on FreeBSD
10/18/2015 01:38 PM - Daniel Curtis

Status: Closed Start date: 10/18/2015
Priority: Normal Due date:

Assignee: Daniel Curtis % Done: 100%
Category: Source Code Management Estimated time: 2.00 hours
Target version: FreeBSD 10 Spent time: 4.50 hours
Description

This is a guide on installing GitLab 8.8 from source with continuous integration on FreeBSD 10.

Prepare the Environment

o Make sure the system is up to date:
pkg update && pkg upgrade
e |nstall a few dependencies:

pkg install sudo bash icu cmake pkgconf git node ruby ruby22-gems logrotate postfix krb5 go wg
et rubygem-bundler portmaster postgresgl94-server redis gmake mercurial

e Add the GitLab user
pw add user -n git -m -s /usr/local/bin/bash -c "GitLab"
® Add git to the redis group:

pw usermod git -G redis

Configure Postfix

e Enable postfix as the mail delivery agent, and disable sendmail:

echo 'postfix_enable="YES"' >> /etc/rc.conf

echo 'sendmail_enable="NO"' >> /etc/rc.conf

echo 'sendmail_submit_enable="NO"' >> /etc/rc.conf
echo 'sendmail_outbound_enable="NO"' >> /etc/rc.conf

echo 'sendmail_msp_gqueue_enable="NO"' >> /etc/rc.conf

Configure PostgreSQL

¢ Initialize, start, and enable postgresql at boot:

echo 'postgresqgl_enable="YES"' >> /etc/rc.conf
service postgresgl initdb
service postgresqgl start
® | og in to postgresql user account

su - pgsqgl

e Connect to postgresql database

psgl —-d templatel

o Create a user for GitLab:

CREATE USER git WITH PASSWORD 'SuperSecretPassword' CREATEDB;

o Create the GitLab production database & grant all privileges on database

CREATE DATABASE gitlabhg _production OWNER git encoding='UTF8';

o Quit the database session

\q
exit

Configure Redis

e Back up the original Redis config file:

cp /usr/local/etc/redis.conf /usr/local/etc/redis.conf.orig

e Disable Redis listening on TCP by setting 'port' to 0

sed -1 '' -e 's/"“port .*/port 0/' /usr/local/etc/redis.conf

e Enable Redis socket

echo 'unixsocket /usr/local/var/run/redis/redis.sock' >> /usr/local/etc/redis.conf

e Grant permission to the socket to all members of the redis group

echo 'unixsocketperm 770' >> /usr/local/etc/redis.conf

e Create the directory which contains the socket

mkdir -p /usr/local/var/run/redis
chown redis:redis /usr/local/var/run/redis
chmod 755 /var/run/redis

e Start and enable redis at boot:

echo 'redis_enable="YES"' >> /etc/rc.conf
service redis start
Install GitLab 8

e Switch to the git user:

su - git

e Clone GitLab repository

git clone https://gitlab.com/gitlab-org/gitlab-ce.git -b 8-8-stable gitlab
cd gitlab

e Copy the example GitLab config

cp config/gitlab.yml.example config/gitlab.yml

e Update GitLab config file, follow the directions at top of file

vi config/gitlab.yml

e Copy the example secrets file

cp config/secrets.yml.example config/secrets.yml
chmod 0600 config/secrets.yml

e Make sure GitLab can write to the log/ and tmp/ directories

chown -R git log/

chown -R git tmp/

chmod -R u+rwX,go-w log/
chmod -R u+rwX tmp/

e Make sure GitLab can write to the tmp/pids/ and tmp/sockets/ directories

chmod -R u+trwX tmp/pids/
chmod -R u+rwX tmp/sockets/

e Make sure GitLab can write to the public/uploads/ directory

chmod -R u+rwX public/uploads

e Change the permissions of the directory where Cl build traces are stored

chmod -R u+rwX builds/

Copy the example Unicorn config
cp config/unicorn.rb.example config/unicorn.rb

e Copy the example Rack attack config

cp config/initializers/rack_attack.rb.example config/initializers/rack_attack.rb

e Configure Git global settings for git user, used when editing via web editor

git config --global core.autocrlf input

e Configure Redis connection settings

cp config/resque.yml.example config/resque.yml

e Change the Redis socket path if you are not using the default Debian / Ubuntu configuration

vi config/resque.yml

o And modify the following parameter:

production: unix:/usr/local/var/run/redis/redis.sock

® Configure GitLab DB Settings:

cp config/database.yml.postgresqgl config/database.yml

e Change the database credentials if necessary:

vi config/database.yml

* Make config/database.yml readable to git only

chmod o-rwx config/database.yml

¢ |nstall the gems for PostgreSQL:

bundle install --deployment --without development test mysgl aws kerberos

Install GitLab Shell

* Run the installation task for gitlab-shell:

bundle exec rake gitlab:shell:install RAILS_ENV=production

1. By default, the gitlab-shell config is generated from your main GitLab config, double check the settings are correct:
vi /home/git/gitlab-shell/config.yml

Install GitLab Workhorse

e |nstall the gitlab workhorse:

cd /home/git

git clone https://gitlab.com/gitlab-org/gitlab-workhorse.git
cd gitlab-workhorse

git checkout 0.6.5

make

Initialize Database

e |nitialize the database:

cd /home/git/gitlab
bundle exec rake gitlab:setup RAILS_ENV=production

e Exit out of the git user, back into root:

exit

Install Init Script

* Download the init script:

wget -O /usr/local/etc/rc.d/gitlab https://gitlab.com/gitlab-org/gitlab-recipes/raw/master/ini
t/init/freebsd/gitlab-unicorn

e Fix the shell environment for the init script:

sed -1 "' —e 's/\#\!\ \/bin\/sh/\#\!\ \/usr\/local\/bin\/bash' /usr/local/etc/rc.d/gitlab

o Make the init script executable:

chmod +x /usr/local/etc/rc.d/gitlab

Check Configuration and Compile Assets

e Check the configuration:

cd /home/git/gitlab
bundle exec rake gitlab:env:info RAILS_ENV=production

e Compile all of the assets for GitLab:

bundle exec rake assets:precompile RAILS_ENV=production
e Start and enable gitlab at boot:

echo 'gitlab_enable="YES"' >> /etc/rc.conf
service gitlab start

Install Nginx

e |nstall nginx:
pkg install nginx
e Start and enable nginx at boot:

echo 'nginx_enable="YES"' >> /etc/rc.conf
service nginx start

e Create a configuration directory to make managing individual server blocks easier
mkdir /usr/local/etc/nginx/conf.d
e Edit the main nginx config file:

vi /usr/local/etc/nginx/nginx.conf
o And strip down the config file and add the include statement at the end to make it easier to handle various server blocks:
worker_processes 1;
error_log /var/log/nginx-error.log;

events {
worker_connections 1024;

http {
include mime.types;
default_type application/octet—-stream;
sendfile on;

keepalive_timeout 65;

# Load config files from the /etc/nginx/conf.d directory
include /usr/local/etc/nginx/conf.d/*.conf;

e Create the gitlab nginx config:

vi /usr/local/etc/nginx/conf.d/gitlab.example.com.conf

o And add the following:

upstream gitlab-workhorse {
server unix:/home/git/gitlab/tmp/sockets/gitlab-workhorse.socket fail_timeout=0;
server {
listen 80;
server_name gitlab.example.com;
server_tokens off;
root /home/git/gitlab/public;
access_log /var/log/gitlab.example.com—access.log;
error_log /var/log/gitlab.example.com-error.log;

location / {
client_max_body_size 0;

gzip off;

proxy_read_timeout 300;
proxy_connect_timeout 300;
proxy_redirect off;

proxy_http_version 1.1;

proxy_set_header Host Shttp_host;
proxy_set_header X-Real-IP Sremote_addr;
proxy_set_header X-Forwarded-For Sproxy_add_x_forwarded_for;
proxy_set_header X-Forwarded-Proto Sscheme;

proxy_pass http://gitlab-workhorse;

Install GitLab Runner

e Download the binary for 64-bit systems:
wget —-O /usr/local/bin/gitlab-ci-multi-runner https://gitlab-ci-multi-runner-downloads.s3.amaz
onaws.com/latest/binaries/gitlab-ci-multi-runner-freebsd-amdé64

o NOTE: If the host architecture is 32-bit download the 386 version of the gitlab runner:

wget —-O /usr/local/bin/gitlab-ci-multi-runner https://gitlab-ci-multi-runner-downloads.s3.
amazonaws.com/latest/binaries/gitlab-ci-multi-runner-freebsd-386

* Give it permissions to execute:

chmod +x /usr/local/bin/gitlab-ci-multi-runner

® Open a web browser and go to http:/gitlab.example.com, then log in as the admin user:
o Username root, password 5ivel lfe

¢ Next navigate to http:/gitlab.example.com/ci/admin/runners to get the token

Then switch to the git user

Finally register the gitlab runner instance:

gitlab-ci-multi-runner register —--non-interactive —-url "http://gitlab.example.com/ci" —--regis
tration-token "5777041dc9651d08ff77" —--description "gitlab-ce-ruby-2.1" --executor "shell" bui
lds_dir = "" shell = "bash"

Resources
http://gitlab.example.com
http://gitlab.example.com/ci/admin/runners

e http://doc.qgitlab.com/ce/install/installation.html

¢ https://github.com/gitlabhqg/gitlab-recipes/blob/master/install/freebsd/freebsd-10.md

o https:/qitlab.com/gitlab-org/gitlab-ci-multi-runner/blob/master/docs/development/README.md

History

#1 - 10/18/2015 01:39 PM - Daniel Curtis
- Tracker changed from Bug to Support

#2 - 10/19/2015 12:49 PM - Daniel Curtis

- Description updated

#3 - 10/19/2015 12:52 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 0 to 30

#4 - 10/19/2015 01:09 PM - Daniel Curtis

- Description updated

#5 - 10/19/2015 02:56 PM - Daniel Curtis

- Description updated

#6 - 10/19/2015 03:43 PM - Daniel Curtis
- Description updated

- % Done changed from 30 to 60

#7 - 10/19/2015 04:04 PM - Daniel Curtis

- Description updated

#8 - 10/19/2015 05:01 PM - Daniel Curtis

- Description updated

#9 - 10/20/2015 07:44 PM - Daniel Curtis

- Description updated

- Status changed from In Progress to Resolved

- % Done changed from 60 to 100

#10 - 10/20/2015 07:52 PM - Daniel Curtis

- Description updated

#11 - 10/20/2015 09:06 PM - Daniel Curtis

- Description updated

#12 - 11/27/2015 03:54 PM - Daniel Curtis

- Status changed from Resolved to Closed

#13 - 02/28/2016 03:16 PM - Daniel Curtis

- Description updated

#14 - 02/28/2016 08:54 PM - Daniel Curtis

- Description updated

#15 - 05/24/2016 12:04 PM - Daniel Curtis

- Description updated

#16 - 05/24/2016 12:07 PM - Daniel Curtis
https://gitlab.com/gitlab-org/gitlab-ci-multi-runner/blob/master/docs/development/README.md

- Subject changed from Install GitLab 8 on FreeBSD to Install GitLab 8 From Source on FreeBSD

- Description updated

#17 - 05/24/2016 01:25 PM - Daniel Curtis

- Description updated
